package com.ruoyi.web.controller.topology;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.topology.TopologyData;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.common.core.websocket.WebSocketServer;
import com.ruoyi.topology.service.ITopologyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/3/29 10:21
 */
@RestController
@RequestMapping("/topology")
public class IndexController extends BaseController {

    @Value(("${ruoyi.profile}"))
    private String profile;
    @Autowired
    private ITopologyService iTopologyService;
    @Autowired
    private WebSocketServer webSocketServer;
    /**
     * 保存组态数据
     *
     * @param topologyData
     * @return AjaxResult
     */
    @PostMapping("/save")
    public AjaxResult save(@RequestBody TopologyData topologyData) throws IOException {
        List<TopologyData> list =null;
        TopologyData t=null;
        if (topologyData.getId() == null) {
            //将当前用的ID存入数据库，并返回组态id
            topologyData.setUserId( SecurityUtils.getLoginUser().getUser().getUserId() );
            iTopologyService.saveUserIdToId(topologyData ) ;
            FileUtils.createdFile( topologyData.getId() + ".json", "", profile, JSONObject.toJSONString( topologyData.getData() ) );
            return AjaxResult.success( topologyData );
        }else{
            t =iTopologyService.getTopologyById( topologyData.getId() );
            if(t!=null){
                FileUtils.createdFile( topologyData.getId() + ".json", "", profile, JSONObject.toJSONString( topologyData.getData() ) );
                return AjaxResult.success( topologyData );
            }
        }
        return AjaxResult.error( "保存失败，请检查id是否存在" );

    }

    @GetMapping("/preview")
    public AjaxResult preview() {
        TopologyData topologyData = new TopologyData();
        topologyData.setUserId( SecurityUtils.getLoginUser().getUser().getUserId() );
        List<TopologyData> list = iTopologyService.getTopology( topologyData );
        return AjaxResult.success( list );
    }

    @GetMapping("/getTopology/{id}")
    public AjaxResult getTopology(@PathVariable("id") Integer id) throws IOException {
        TopologyData topologyData = new TopologyData();
        topologyData.setId( id );
        List<TopologyData> list = iTopologyService.getTopology( topologyData );
        File file = null;
        JSONObject json = null;

        file = new File( profile + id + ".json" );
        if (!file.exists()) {
            throw new FileNotFoundException( profile + id + ".json" );
        }
        json = JSONObject.parseObject( FileUtils.readFileJson( file ) );
        for (TopologyData t : list) {
            t.setData( json );
        }
        return AjaxResult.success( list );
    }

    @DeleteMapping("/deleteTopology/{id}")
    public AjaxResult deleteTopology(@PathVariable("id") Integer id) throws IOException {
        return AjaxResult.success();
    }

    @GetMapping("/test")
    public void test() throws IOException {
        JSONObject jsonObject= JSON.parseObject( "{\n" +
                "      tag: 'numA',  //tag节点\n" +
                "      fontColor: 'red', //数据颜色\n" +
                "      text: 'test', //文本内容\n" +
                "    }" );
        webSocketServer.sendInfo(jsonObject.toJSONString() ,"1" );
    }
}
