package com.ruoyi.framework.mail.service;

import org.springframework.core.io.FileSystemResource;

/**
 * 发送邮件接口
 * @author jianglw
 * @version 1.0
 * @date 2021/1/29 18:38
 */
public interface IMailService {
    /**
     * 发送文本邮件
     * @param to 收件人
     * @param subject 主题
     * @param content 内容
     */
    void sendSimpleMail(String to, String subject, String content);

    /**
     * 发送HTML邮件
     * @param to 收件人
     * @param subject 主题
     * @param content 内容
     */
    public void sendHtmlMail(String to, String subject, String content);



    /**
     * 发送带附件的邮件
     * @param from 发送人
     * @param to 收件人
     * @param subject 主题
     * @param content 内容
     */
    public void sendAttachmentsMail(String from,String to, String subject, String content,  FileSystemResource file);
}
